#ifndef EIDP_SIMPLE_STACK
#define EIDP_SIMPLE_STACK
#include <iostream>

template <typename T>
class simple_stack {
 private:
  T *data_;
  unsigned int size_;
  unsigned int capacity_;
  void set_capacity(unsigned int new_capacity);
  void error(char const *info) const;

 public:
  // Aufgabe a.):
  simple_stack();
  ~simple_stack();
  simple_stack(simple_stack const &other);
  simple_stack &operator=(simple_stack const &other);

  // Aufgabe b.):
  // (implementieren Sie auch die Funktion set_capacity)
  void push(T const &object);
  void pop();

  // Aufgabe c.):
  T &top() const;
  T &top(unsigned int offset) const;
  T &bottom() const;
  T &bottom(unsigned int offset) const;
  unsigned int size() const;
};

template <typename T>
void simple_stack<T>::error(char const *info) const {
  std::cerr << info << std::endl;
  exit(1);
}

// Aufgabe 2a.) ================================================================
// =============================================================================

// Implementieren Sie hier die Konstruktoren, den Destruktor, 
// und den Zuweisungsoperator.


// Aufgabe 2b.) ================================================================
// =============================================================================

// Implementieren Sie hier die Funktionen set_capacity, push und pop.


// Aufgabe 2c.) ================================================================
// =============================================================================

// Implementieren Sie hier die Funktionen top, bottom und size


#endif
