#include <iostream>

#include "simple_stack.hpp"
using namespace std;

int main() {
  simple_stack<unsigned long long> fibonacci_stack;

  cout << "Stack created." << endl;

  fibonacci_stack.push(1);
  fibonacci_stack.push(1);

  for (unsigned int i = 2; i < 50; i++) {
    fibonacci_stack.push(fibonacci_stack.top() + fibonacci_stack.top(1));
  }

  cout << "The 50th Fibonacci number is " << fibonacci_stack.top() << endl;
  cout << "The 20th Fibonacci number is " << fibonacci_stack.top(30) << endl;

  simple_stack<unsigned long long> copy1(fibonacci_stack);
  simple_stack<unsigned long long> copy2;
  copy2 = fibonacci_stack;

  cout << "Copies created." << endl;

  for (unsigned int i = 0; i < 40; i++) fibonacci_stack.pop();
  for (unsigned int i = 0; i < 45; i++) copy1.pop();

  cout << "The 4th Fibonacci number is " << fibonacci_stack.top(6) << endl;
  cout << "The 4th Fibonacci number is " << copy1.top(1) << endl;
  cout << "The 4th Fibonacci number is " << copy2.top(46) << endl;

  cout << "The first 10 Fibonacci numbers are:" << endl;
  cout << copy2.bottom();
  for (unsigned int i = 1; i < 10; i++) cout << ", " << copy2.bottom(i);
  cout << endl;

  return 0;
}
